"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const render_1 = require("./render");
const mount_1 = require("./mount");
/** render wrapper */
function _r(props) {
    return render_1.render(this, this.instance, props);
}
/** wrapped mount */
function _wm(options) {
    // eslint-disable-next-line
    const target = options && options.target;
    if (target === null)
        return null;
    // eslint-disable-next-line
    const props = options && options.props;
    // eslint-disable-next-line
    const count = !((options && options.count) === false);
    const targetElement = mount_1._m(this.instance, this, target, props, count);
    const els = this.els;
    if (!els.includes(targetElement)) {
        els.push(targetElement);
    }
    return targetElement;
}
/** wrapped unmount */
function _wu(options) {
    // eslint-disable-next-line
    const target = options && options.target;
    // eslint-disable-next-line
    const delay = (options && options.delay) || 0;
    // eslint-disable-next-line
    const count = !((options && options.count) === false);
    if (target === null)
        return;
    if (delay === 0)
        mount_1._u(this.instance, this, target, count);
    else {
        setTimeout(() => mount_1._u(this.instance, this, target, count), delay);
    }
}
/** create CNode */
const _cc = function (instance, $, props, children) {
    return {
        instance,
        $,
        props,
        children,
        els: [],
        render: _r,
        mount: _wm,
        unmount: _wu
    };
};
exports.c = function (instance, $, props, children) {
    if (Array.isArray($)) {
        return _cc(instance, { $: null }, null, $);
    }
    if (Array.isArray(props)) {
        return _cc(instance, $, null, props);
    }
    else if (Array.isArray(children)) {
        return _cc(instance, $, props, children);
    }
    else {
        return _cc(instance, $, props, null);
    }
};
