"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
/** get count of element */
function _gc(el) {
    const count = el.getAttribute('mount-count');
    if (count === null)
        return 0;
    return Number(count);
}
exports._gc = _gc;
/** set count of element */
function _sc(el, count) {
    el.setAttribute('mount-count', String(count));
}
exports._sc = _sc;
/** unmount */
function _u(intance, node, target, count) {
    const els = node.els;
    if (target === undefined) {
        els.forEach(utils_1._re);
        node.els = [];
    }
    else if (typeof target === 'string' || typeof target === 'number') {
        const targetElement = utils_1._qe(target);
        // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
        if (targetElement && els.includes(targetElement)) {
            const mountCount = _gc(targetElement);
            if (!count || mountCount === 1) {
                utils_1._re(targetElement);
                node.els = els.filter(el => el !== targetElement);
            }
            else {
                _sc(targetElement, mountCount - 1);
            }
        }
    }
    else if (els.includes(target)) {
        const mountCount = _gc(target);
        if (!count || mountCount === 1) {
            utils_1._re(target);
            node.els = els.filter(el => el !== target);
        }
        else {
            _sc(target, mountCount - 1);
        }
    }
}
exports._u = _u;
/** mount */
function _m(instance, node, target, props, count) {
    let targetElement = null;
    if (target === undefined) {
        targetElement = document.createElement('style');
        document.head.appendChild(targetElement);
    }
    else if (typeof target === 'string' || typeof target === 'number') {
        targetElement = utils_1._qe(target);
        if (targetElement === null) {
            targetElement = utils_1._ce(target);
            document.head.appendChild(targetElement);
            if (count) {
                _sc(targetElement, 1);
            }
        }
        else {
            if (count) {
                _sc(targetElement, _gc(targetElement) + 1);
            }
            return targetElement;
        }
    }
    else {
        targetElement = target;
        const mountCount = _gc(targetElement);
        if (mountCount > 0) {
            if (count) {
                _sc(targetElement, mountCount + 1);
            }
            return target;
        }
    }
    const style = node.render(props);
    if (targetElement.innerHTML !== style) {
        targetElement.innerHTML = style;
    }
    return targetElement;
}
exports._m = _m;
